#ifndef _PROPERTYPANEL_H
#define _PROPERTYPANEL_H

#include <wx/wx.h>

class PropertyPanel: public wxPanel
{
public:
	enum
	{
		ID_BUTTON_CREATERIGIDBODIES = 10,
		ID_BUTTON_RELEASERIGIDBODIES,
		ID_TEXT_RESTITUTION,
		ID_SLIDER_RESTITUTION,
		ID_TEXT_FRICTION,
		ID_SLIDER_FRICTION,
		ID_TEXT_LINEARDAMPING,
		ID_SLIDER_LINEARDAMPING,
		ID_TEXT_ANGULARDAMPING,
		ID_SLIDER_ANGULARDAMPING,
	};
	
	//
	PropertyPanel(wxWindow *parent, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);
	
	//
	~PropertyPanel(void);

private:
	//
	void CreateControl();

	wxButton *m_pButtonCreateRigidBodies;
	wxButton *m_pButtonReleaseRigidBodies;
	wxTextCtrl *m_pTextRestitution;
	wxSlider *m_pSliderRestitution;
	wxTextCtrl *m_pTextFriction;
	wxSlider *m_pSliderFriction;
	wxTextCtrl *m_pTextLinearDamping;
	wxSlider *m_pSliderLinearDamping;
	wxTextCtrl *m_pTextAngularDamping;
	wxSlider *m_pSliderAngularDamping;

public:
	//
	void UpdatePanel();

	//
	void OnSize(wxSizeEvent& event);
	
	//
	void OnButtonCreateRigidBodies(wxCommandEvent& event);

	//
	void OnButtonReleaseRigidBodies(wxCommandEvent& event);

	//
	void OnSliderRestitution(wxCommandEvent& event);

	//
	void OnSliderFriction(wxCommandEvent& event);

	//
	void OnSliderLinearDamping(wxCommandEvent& event);

	//
	void OnSliderAngularDamping(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()
};

#endif

