#ifndef  _RENDER_WINDOW_H
#define  _RENDER_WINDOW_H

#include <d3d9.h>
#include <d3dx9.h>
#include <wx/wx.h>

class RenderWindow: public wxWindow
{
public:
	RenderWindow(wxWindow *parent, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);
	~RenderWindow(void);

	void OnIdle(wxIdleEvent& event);
	void OnSize(wxSizeEvent& event);
	void OnEnterWindow( wxMouseEvent& event);
	
	virtual void OnMouseWheel( wxMouseEvent& event);
	virtual void OnMouse(wxMouseEvent& event);
	virtual void OnMouseLDClick(wxMouseEvent& event);
	virtual void OnLButtonDown(wxMouseEvent& event);
	virtual void OnLButtonUp(wxMouseEvent& event);
    virtual void OnDraw(wxEraseEvent& event);
	virtual void OnChar(wxKeyEvent& event);

protected:
	float					m_fSphereThetaAngle;
	float					m_fSpherePhiAngle;
	float					m_fSphereLength;
	D3DXVECTOR3             m_vTranslation;

	D3DXMATRIX              m_viewM;
	D3DXMATRIX              m_projectionM;
	D3DXVECTOR3             m_vRayPosition;
	D3DXVECTOR3             m_vRayDirection;

	int m_iScreenX;
	int m_iScreenY;
	int m_iScreenPreX;
	int m_iScreenPreY;

	virtual void UpdateMainCamera();
	void UpdateRay();
	void SetupMainCamera();
	void SetupLights();

public:
	virtual void Update();
	virtual void Render();

	DECLARE_EVENT_TABLE();
 };

#endif