#include <RigidBodyApp.h>
#include <RigidBodyFrame.h>
#include <Demo/Scene.h>
#include <Render/D3DDrawUtil.h>
#include <Time/Timer.h>

#include <btBulletDynamicsCommon.h>

IMPLEMENT_APP(RigidBodyApp);

bool RigidBodyApp::OnInit()
{
	m_pMainFrame = new RigidBodyFrame("RigidBody", wxPoint(50, 50), wxSize(640, 480));

	Scene::CreateInstance();
	D3DDrawUtil::CreateInstance(static_cast<HWND>(m_pMainFrame->GetHWND()));
	Timer::CreateInstance();
	
	m_pMainFrame->UpdatePanel();
	m_pMainFrame->Show(TRUE);
	SetTopWindow(m_pMainFrame);

	return TRUE;
}

int RigidBodyApp::OnExit()
{
	Scene::DestoryInstance();
	D3DDrawUtil::DestoryInstance();
	Timer::DestoryInstance();

	return wxApp::OnExit();
}

