#include <RigidBodyFrame.h>
#include <Panel/RenderWindow.h>
#include <Panel/PropertyPanel.h>

BEGIN_EVENT_TABLE(RigidBodyFrame, wxFrame)

END_EVENT_TABLE()

RigidBodyFrame::RigidBodyFrame(const wxString& title, const wxPoint& pos, const wxSize& size): wxFrame((wxFrame*)NULL, -1, title, pos, size)
{
	CreateControl();
}

RigidBodyFrame::~RigidBodyFrame(void)
{
	m_mgr.UnInit();
}

void RigidBodyFrame::CreateControl()
{
	m_mgr.SetManagedWindow(this);
	{
		{
			SetIcon(wxIcon(wxT("./icon/bullet.ico"), wxBITMAP_TYPE_ICO));
		}

		m_pRenderWindow = new RenderWindow(this);
		m_pPropertyPanel = new PropertyPanel(this);
				
 		m_mgr.AddPane(m_pRenderWindow,  wxAuiPaneInfo().Name(wxT("Main")).
			CenterPane().PaneBorder(false).BestSize(wxSize(600, 480)).MinSize(wxSize(600, 480)));

		m_mgr.AddPane(m_pPropertyPanel, wxAuiPaneInfo().
			Name(wxT("Property")).Caption(wxT("Property")).Right().Layer(1).BestSize(wxSize(250,-1)).MinSize(wxSize(250, -1)));
	}

	{
		CreateStatusBar();
		// set statusbar text
		SetStatusText(_T("Welcome to Bullet!"));
	}

	m_mgr.Update();

	Fit();
}

void RigidBodyFrame::UpdatePanel()
{
	m_pPropertyPanel->UpdatePanel();
}