#include <Time/Timer.h>
#include <Windows.h>

Timer* Timer::m_pInstance = NULL;

void Timer::CreateInstance()
{
	m_pInstance = new Timer();
}

Timer* Timer::Instance()
{
	return m_pInstance;
}

void Timer::DestoryInstance()
{
	if(!m_pInstance)
		return;

	delete m_pInstance;
	m_pInstance = NULL;
}

Timer::Timer(void):
m_deltaTime(0.0f),
	m_scale(1.0f)
{
}

Timer::~Timer(void)
{
}

void Timer::UpdateDeltaTime()
{
	static bool bFirst = true;
	static LARGE_INTEGER freq;
	static LARGE_INTEGER prevCount;
	static LARGE_INTEGER currentCount;

	if(bFirst)
	{
		QueryPerformanceCounter(&prevCount);
		bFirst = false;
	}
	else
	{
		prevCount = currentCount;
	}

	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&currentCount);

	m_deltaTime = (float)((long double)(currentCount.QuadPart - prevCount.QuadPart) / (long double) freq.QuadPart);
}

float Timer::GetDeltaTime()
{
	return m_scale*m_deltaTime;
}

float Timer::GetTime()
{
	LARGE_INTEGER freq;
	LARGE_INTEGER count;

	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&count);

	return (float)((long double)(count.QuadPart) / (long double) freq.QuadPart);
}

float Timer::GetTimeScale()
{
	return m_scale;
}

void Timer::SetTimeScale(float scale)
{
	m_scale = scale;
}



